var ColorKeywords;
(function (ColorKeywords) {
  ColorKeywords["transparent"] = "rgba(0,0,0,0)";
  ColorKeywords["black"] = "#000000";
  ColorKeywords["silver"] = "#C0C0C0";
  ColorKeywords["gray"] = "#808080";
  ColorKeywords["white"] = "#FFFFFF";
  ColorKeywords["maroon"] = "#800000";
  ColorKeywords["red"] = "#FF0000";
  ColorKeywords["purple"] = "#800080";
  ColorKeywords["fuchsia"] = "#FF00FF";
  ColorKeywords["green"] = "#008000";
  ColorKeywords["lime"] = "#00FF00";
  ColorKeywords["olive"] = "#808000";
  ColorKeywords["yellow"] = "#FFFF00";
  ColorKeywords["navy"] = "#000080";
  ColorKeywords["blue"] = "#0000FF";
  ColorKeywords["teal"] = "#008080";
  ColorKeywords["aqua"] = "#00FFFF";
  ColorKeywords["aliceblue"] = "#f0f8ff";
  ColorKeywords["antiquewhite"] = "#faebd7";
  ColorKeywords["aquamarine"] = "#7fffd4";
  ColorKeywords["azure"] = "#f0ffff";
  ColorKeywords["beige"] = "#f5f5dc";
  ColorKeywords["bisque"] = "#ffe4c4";
  ColorKeywords["blanchedalmond"] = "#ffebcd";
  ColorKeywords["blueviolet"] = "#8a2be2";
  ColorKeywords["brown"] = "#a52a2a";
  ColorKeywords["burlywood"] = "#deb887";
  ColorKeywords["cadetblue"] = "#5f9ea0";
  ColorKeywords["chartreuse"] = "#7fff00";
  ColorKeywords["chocolate"] = "#d2691e";
  ColorKeywords["coral"] = "#ff7f50";
  ColorKeywords["cornflowerblue"] = "#6495ed";
  ColorKeywords["cornsilk"] = "#fff8dc";
  ColorKeywords["crimson"] = "#dc143c";
  ColorKeywords["cyan"] = "#00ffff";
  ColorKeywords["darkblue"] = "#00008b";
  ColorKeywords["darkcyan"] = "#008b8b";
  ColorKeywords["darkgoldenrod"] = "#b8860b";
  ColorKeywords["darkgray"] = "#a9a9a9";
  ColorKeywords["darkgreen"] = "#006400";
  ColorKeywords["darkgrey"] = "#a9a9a9";
  ColorKeywords["darkkhaki"] = "#bdb76b";
  ColorKeywords["darkmagenta"] = "#8b008b";
  ColorKeywords["darkolivegreen"] = "#556b2f";
  ColorKeywords["darkorange"] = "#ff8c00";
  ColorKeywords["darkorchid"] = "#9932cc";
  ColorKeywords["darkred"] = "#8b0000";
  ColorKeywords["darksalmon"] = "#e9967a";
  ColorKeywords["darkseagreen"] = "#8fbc8f";
  ColorKeywords["darkslateblue"] = "#483d8b";
  ColorKeywords["darkslategray"] = "#2f4f4f";
  ColorKeywords["darkslategrey"] = "#2f4f4f";
  ColorKeywords["darkturquoise"] = "#00ced1";
  ColorKeywords["darkviolet"] = "#9400d3";
  ColorKeywords["deeppink"] = "#ff1493";
  ColorKeywords["deepskyblue"] = "#00bfff";
  ColorKeywords["dimgray"] = "#696969";
  ColorKeywords["dimgrey"] = "#696969";
  ColorKeywords["dodgerblue"] = "#1e90ff";
  ColorKeywords["firebrick"] = "#b22222";
  ColorKeywords["floralwhite"] = "#fffaf0";
  ColorKeywords["forestgreen"] = "#228b22";
  ColorKeywords["gainsboro"] = "#dcdcdc";
  ColorKeywords["ghostwhite"] = "#f8f8ff";
  ColorKeywords["gold"] = "#ffd700";
  ColorKeywords["goldenrod"] = "#daa520";
  ColorKeywords["greenyellow"] = "#adff2f";
  ColorKeywords["grey"] = "#808080";
  ColorKeywords["honeydew"] = "#f0fff0";
  ColorKeywords["hotpink"] = "#ff69b4";
  ColorKeywords["indianred"] = "#cd5c5c";
  ColorKeywords["indigo"] = "#4b0082";
  ColorKeywords["ivory"] = "#fffff0";
  ColorKeywords["khaki"] = "#f0e68c";
  ColorKeywords["lavender"] = "#e6e6fa";
  ColorKeywords["lavenderblush"] = "#fff0f5";
  ColorKeywords["lawngreen"] = "#7cfc00";
  ColorKeywords["lemonchiffon"] = "#fffacd";
  ColorKeywords["lightblue"] = "#add8e6";
  ColorKeywords["lightcoral"] = "#f08080";
  ColorKeywords["lightcyan"] = "#e0ffff";
  ColorKeywords["lightgoldenrodyellow"] = "#fafad2";
  ColorKeywords["lightgray"] = "#d3d3d3";
  ColorKeywords["lightgreen"] = "#90ee90";
  ColorKeywords["lightgrey"] = "#d3d3d3";
  ColorKeywords["lightpink"] = "#ffb6c1";
  ColorKeywords["lightsalmon"] = "#ffa07a";
  ColorKeywords["lightseagreen"] = "#20b2aa";
  ColorKeywords["lightskyblue"] = "#87cefa";
  ColorKeywords["lightslategray"] = "#778899";
  ColorKeywords["lightslategrey"] = "#778899";
  ColorKeywords["lightsteelblue"] = "#b0c4de";
  ColorKeywords["lightyellow"] = "#ffffe0";
  ColorKeywords["limegreen"] = "#32cd32";
  ColorKeywords["linen"] = "#faf0e6";
  ColorKeywords["magenta"] = "#ff00ff";
  ColorKeywords["mediumaquamarine"] = "#66cdaa";
  ColorKeywords["mediumblue"] = "#0000cd";
  ColorKeywords["mediumorchid"] = "#ba55d3";
  ColorKeywords["mediumpurple"] = "#9370db";
  ColorKeywords["mediumseagreen"] = "#3cb371";
  ColorKeywords["mediumslateblue"] = "#7b68ee";
  ColorKeywords["mediumspringgreen"] = "#00fa9a";
  ColorKeywords["mediumturquoise"] = "#48d1cc";
  ColorKeywords["mediumvioletred"] = "#c71585";
  ColorKeywords["midnightblue"] = "#191970";
  ColorKeywords["mintcream"] = "#f5fffa";
  ColorKeywords["mistyrose"] = "#ffe4e1";
  ColorKeywords["moccasin"] = "#ffe4b5";
  ColorKeywords["navajowhite"] = "#ffdead";
  ColorKeywords["oldlace"] = "#fdf5e6";
  ColorKeywords["olivedrab"] = "#6b8e23";
  ColorKeywords["orange"] = "#ffa500";
  ColorKeywords["orangered"] = "#ff4500";
  ColorKeywords["orchid"] = "#da70d6";
  ColorKeywords["palegoldenrod"] = "#eee8aa";
  ColorKeywords["palegreen"] = "#98fb98";
  ColorKeywords["paleturquoise"] = "#afeeee";
  ColorKeywords["palevioletred"] = "#db7093";
  ColorKeywords["papayawhip"] = "#ffefd5";
  ColorKeywords["peachpuff"] = "#ffdab9";
  ColorKeywords["peru"] = "#cd853f";
  ColorKeywords["pink"] = "#ffc0cb";
  ColorKeywords["plum"] = "#dda0dd";
  ColorKeywords["powderblue"] = "#b0e0e6";
  ColorKeywords["rosybrown"] = "#bc8f8f";
  ColorKeywords["royalblue"] = "#4169e1";
  ColorKeywords["saddlebrown"] = "#8b4513";
  ColorKeywords["salmon"] = "#fa8072";
  ColorKeywords["sandybrown"] = "#f4a460";
  ColorKeywords["seagreen"] = "#2e8b57";
  ColorKeywords["seashell"] = "#fff5ee";
  ColorKeywords["sienna"] = "#a0522d";
  ColorKeywords["skyblue"] = "#87ceeb";
  ColorKeywords["slateblue"] = "#6a5acd";
  ColorKeywords["slategray"] = "#708090";
  ColorKeywords["snow"] = "#fffafa";
  ColorKeywords["springgreen"] = "#00ff7f";
  ColorKeywords["steelblue"] = "#4682b4";
  ColorKeywords["tan"] = "#d2b48c";
  ColorKeywords["thistle"] = "#d8bfd8";
  ColorKeywords["tomato"] = "#ff6347";
  ColorKeywords["turquoise"] = "#40e0d0";
  ColorKeywords["violet"] = "#ee82ee";
  ColorKeywords["wheat"] = "#f5deb3";
  ColorKeywords["whitesmoke"] = "#f5f5f5";
  ColorKeywords["yellowgreen"] = "#9acd32";
})(ColorKeywords || (ColorKeywords = {}));

/**
 * from https://github.com/DataV-Team/Color
 */
/**
 * @description Test if a hex color
 * @param {string} color color string
 * @return {boolean} Test result
 */
function isHex(color) {
  if (typeof color !== 'string') return false;
  color = color.toLowerCase();
  return /^#([0-9a-fA-f]{3}|[0-9a-fA-f]{6})$/.test(color);
}
/**
 * @description Test if a rgb color
 * @param {string} color color string
 * @return {boolean} Test result
 */
function isRgb(color) {
  if (typeof color !== 'string') return false;
  color = color.toLowerCase();
  return /^(rgb\(|RGB\()/.test(color);
}
/**
 * @description Test if a rgba color
 * @param {string} color color string
 * @return {boolean} Test result
 */
function isRgba(color) {
  if (typeof color !== 'string') return false;
  color = color.toLowerCase();
  return /^(rgba|RGBA)/.test(color);
}
/**
 * @description Test if a rgb or rgba color
 * @param {string} color color string
 * @return {boolean} Test result
 */
function isRgbOrRgba(color) {
  return /^(rgb|rgba|RGB|RGBA)/.test(color);
}
/**
 * @description Get color by keyword
 * @param {keyof typeof ColorKeywords} keyword Color keyword like red, green and etc.
 * @return {ColorKeywords} Hex or rgba color
 */
function getColorByKeyword(keyword) {
  return ColorKeywords[keyword];
}
/**
 * @description Color validator
 * @param {string} color Hex|Rgb|Rgba color or color keywords
 * @return {string} Color (Invalid input will throw an error)
 */
function validator(color) {
  if (isHex(color) || isRgbOrRgba(color)) return color;
  var keywordColor = getColorByKeyword(color);
  if (!keywordColor) throw new Error("Color: Invalid Input of " + color);
  return keywordColor;
}
/**
 * @description Get the rgb value of the hex color
 * @param {string} color Hex color
 * @return {RgbValue} Rgb value of the color
 */
function getRgbValueFromHex(color) {
  color = color.replace('#', '');
  if (color.length === 3) color = Array.from(color).map(function (hexNum) {
    return hexNum + hexNum;
  }).join('');
  var colorValues = color.split('');
  return new Array(3).fill(0).map(function (_, i) {
    return parseInt("0x" + colorValues[i * 2] + colorValues[i * 2 + 1]);
  });
}
/**
 * @description Get the rgb value of the rgb/rgba color
 * @param {string} color Hex color
 * @return {RgbValue} Rgb value of the color
 */
function getRgbValueFromRgb(color) {
  return color.replace(/rgb\(|rgba\(|\)/g, '').split(',').slice(0, 3).map(function (n) {
    return parseInt(n);
  });
}
/**
 * @description Get the Rgb value of the color
 * @param {string} color Hex|Rgb|Rgba color or color keyword
 * @return {RgbValue} Rgb value of the color
 */
function getRgbValue(color) {
  var validColor = validator(color);
  var lowerColor = validColor.toLowerCase();
  return isHex(lowerColor) ? getRgbValueFromHex(lowerColor) : getRgbValueFromRgb(lowerColor);
}
/**
 * @description Get the opacity of color
 * @param {string} color Hex|Rgb|Rgba color or color keyword
 * @return {number} Color opacity
 */
function getOpacity(color) {
  var validColor = validator(color);
  if (!isRgba(validColor)) return 1;
  return Number(validColor.toLowerCase().split(',').slice(-1)[0].replace(/[)|\s]/g, ''));
}
/**
 * @description Get the Rgba value of the color
 * @param {string} color Hex|Rgb|Rgba color or color keyword
 * @return {RgbaValue} Rgba value of the color
 */
function getRgbaValue(color) {
  var rgbValue = getRgbValue(color);
  return rgbValue && [].concat(rgbValue, [getOpacity(color)]);
}
/**
 * @description Convert color to Rgb|Rgba color
 * @param {string} color   Hex|Rgb|Rgba color or color keyword
 * @param {number} opacity The opacity of color
 * @return {string} Rgb|Rgba color
 */
function toRgb(color, opacity) {
  var rgbValue = getRgbValue(color);
  return typeof opacity === 'number' ? "rgba(" + rgbValue.join(',') + "," + opacity + ")" : "rgb(" + rgbValue.join(',') + ")";
}
/**
 * @description Convert color to Hex color
 * @param {string} color Hex|Rgb|Rgba color or color keyword
 * @return {string} Hex color
 */
function toHex(color) {
  if (isHex(color)) return color;
  var colorValue = getRgbValue(color);
  var format10To16 = function format10To16(_) {
    return Number(_).toString(16).padStart(2, '0');
  };
  return "#" + colorValue.map(format10To16).join('');
}
/**
 * @description Get Color from Rgb|Rgba value
 * @param {RgbValue|RgbaValue} value Rgb|Rgba color value
 * @return {string} Rgb|Rgba color
 */
function getColorFromRgbValue(value) {
  if (!Array.isArray(value)) throw new Error("getColorFromRgbValue: " + value + " is not an array");
  var length = value.length;
  if (length !== 3 && length !== 4) throw new Error("getColorFromRgbValue: value length should be 3 or 4");
  return (length === 3 ? 'rgb(' : 'rgba(') + value.join(',') + ')';
}
/**
 * Deepen color
 * @param color Hex|Rgb|Rgba color or color keyword
 * @param percent percent of Deepen (1-100)
 * @returns Rgba color
 */
function darken(color, percent) {
  if (percent === void 0) {
    percent = 0;
  }
  var rgbaValue = getRgbaValue(color);
  rgbaValue = rgbaValue.map(function (v, i) {
    return i === 3 ? v : v - Math.ceil(2.55 * percent);
  }).map(function (v) {
    return v < 0 ? 0 : v;
  });
  return getColorFromRgbValue(rgbaValue);
}
/**
 *  Brighten color
 * @param color Hex|Rgb|Rgba color or color keyword
 * @param percent  of brighten (1-100)
 * @returns Rgba color
 */
function lighten(color, percent) {
  if (percent === void 0) {
    percent = 0;
  }
  var rgbaValue = getRgbaValue(color);
  rgbaValue = rgbaValue.map(function (v, i) {
    return i === 3 ? v : v + Math.ceil(2.55 * percent);
  }).map(function (v) {
    return v > 255 ? 255 : v;
  });
  return getColorFromRgbValue(rgbaValue);
}
/**
 *
 * description Adjust color opacity
 * @param color Hex|Rgb|Rgba color or color keyword
 * @param percent  percent of opacity
 * @returns  Rgba color
 */
function fade(color, percent) {
  if (percent === void 0) {
    percent = 100;
  }
  var rgbValue = getRgbValue(color);
  return getColorFromRgbValue([].concat(rgbValue, [percent / 100]));
}

function opacityFn(color, amount) {
  if (amount === void 0) {
    amount = 0;
  }
  var _getRgbaValue = getRgbaValue(color),
    r = _getRgbaValue[0],
    g = _getRgbaValue[1],
    b = _getRgbaValue[2],
    _getRgbaValue$ = _getRgbaValue[3],
    oldOpacity = _getRgbaValue$ === void 0 ? 0 : _getRgbaValue$;
  var opacity = oldOpacity + amount / 100;
  var rgbValue = [r, g, b];
  if (opacity >= 1) return toHex("rgb(" + rgbValue.join(',') + ")");
  return typeof opacity === 'number' ? "rgba(" + rgbValue.join(',') + "," + opacity + ")" : "rgb(" + rgbValue.join(',') + ")";
}
function opacify(color, amount) {
  if (amount === void 0) {
    amount = 0;
  }
  return opacityFn(color, amount);
}
function transparentize(color, amount) {
  if (amount === void 0) {
    amount = 0;
  }
  return opacityFn(color, -amount);
}
function getColorParam(value, postFix) {
  var color = value;
  var type = '';
  var amount = '';
  var result = postFix.match(/^([TOLD])?(\d{0,3})?$/i) || [];
  type = result[1];
  amount = result[2];
  return {
    color: color,
    type: type,
    amount: Number(amount)
  };
}
/**
 * @example
 * ```
 * formatColor('#000', 'T10')
 * ```
 */
function formatColor(value, postFix) {
  // TODO: need improve
  var canFormat = /^rgba?\(.*\)|^#([A-F0-9]{3}){1,2}$/i.test(value);
  if (!canFormat) return value;
  var param = getColorParam(value, postFix);
  var color = param.color,
    type = param.type,
    amount = param.amount;
  if (/^t$/i.test(type)) return transparentize(color, amount);
  if (/^o$/i.test(type)) return opacify(color, amount);
  if (/^d$/i.test(type)) return toHex(darken(color, amount));
  if (/^l$/i.test(type)) return toHex(lighten(color, amount));
  return color;
}

export { darken, fade, formatColor, getColorFromRgbValue, getOpacity, getRgbValue, getRgbaValue, isHex, isRgb, isRgbOrRgba, isRgba, lighten, opacify, opacityFn, toHex, toRgb, transparentize };
//# sourceMappingURL=color-helper.esm.js.map
